#include <Servo.h>

#define BUTTON PD2

Servo myservo;  // create servo object to control a servo
// twelve servo objects can be created on most boards

volatile int pos = 0;    // variable to store the servo position
int step = 10;
int direction = 0;
long ts = 0;

void setup() { 
  myservo.attach(5);
  myservo.write(pos);
  delay(15); 
  
  // Button setup
  DDRD &= ~(1 << BUTTON);
  PORTD |= (1 << BUTTON);
  
  // Interrupt setup
  PCICR |= (1 << PCIE2);
  PCMSK2 |= (1 << PCINT18);
}

ISR(PCINT2_vect)
{
  // Debounce
  if (millis() - ts > 300) {
    ts = millis();
    if (direction == 0) {
      if (pos <= 180)
      pos += step;
      else
        direction = 1;
    } else if (direction == 1) {
      if (pos >= 0)
        pos -= step;
      else
        direction = 0;
    }
  }
}

void loop() {
  myservo.write(pos);
  delay(15); 
}
